## tiny-dnn 1.0.0a3%2Bds

=== debian/rules ===
#!/usr/bin/make -f

CMAKE_FLAGS = -DBUILD_DOCS=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5

ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	ifneq "$(DEB_HOST_ARCH)" "i386"
		CMAKE_FLAGS += -DBUILD_TESTS=ON
	endif
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- docs

override_dh_auto_test:
	dh_auto_test -- run_tests

override_dh_installdocs:
	dh_installdocs
	dh_installdocs -p tiny-dnn-doc --doc-main-package tiny-dnn debian/tmp/usr/share/tiny_dnn/doc/html
