=== debian/changelog ===
tiny-dnn (1.0.0a3+ds-6) unstable; urgency=medium

  * Build with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113577)

 -- Andrius Merkys <merkys@debian.org>  Mon, 06 Oct 2025 02:53:20 -0400

tiny-dnn (1.0.0a3+ds-5) unstable; urgency=medium

  * Do not build tests on i386 (Closes: #1103095)

 -- Andrius Merkys <merkys@debian.org>  Mon, 14 Apr 2025 09:15:27 -0400

tiny-dnn (1.0.0a3+ds-4) unstable; urgency=medium

  * Remove hard-coded CMAKE_CXX_STANDARD (Closes: #1041134)
  * Update Standards-Version to 4.6.2 (no changes).
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Thu, 08 Feb 2024 08:41:09 -0500

tiny-dnn (1.0.0a3+ds-3) unstable; urgency=medium

  * Switch off tbb usage (Closes: #1011664).

 -- Andrius Merkys <merkys@debian.org>  Mon, 30 May 2022 04:37:50 -0400

tiny-dnn (1.0.0a3+ds-2) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.
  * Mark binary packages as Multi-Arch: foreign.

 -- Andrius Merkys <merkys@debian.org>  Wed, 18 May 2022 01:50:51 -0400

tiny-dnn (1.0.0a3+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1010169)

 -- Andrius Merkys <merkys@debian.org>  Wed, 27 Apr 2022 07:01:50 -0400
