=== debian/control ===
Source: tiny-dnn
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen,
 graphviz,
 libcereal-dev,
 libgemmlowp-dev,
 libgmock-dev <!nocheck>,
 libgtest-dev <!nocheck>,
 libstb-dev,
 libtbb-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/tiny-dnn/tiny-dnn
Vcs-Browser: https://salsa.debian.org/deeplearning-team/tiny-dnn
Vcs-Git: https://salsa.debian.org/deeplearning-team/tiny-dnn.git
Rules-Requires-Root: no

Package: tiny-dnn
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 tiny-dnn-doc,
Description: header only deep learning framework in C++
 tiny-dnn is a C++ implementation of deep learning. It is suitable for deep
 learning on limited computational resource, embedded systems and IoT devices.
 .
 Features:
 .
  * Reasonably fast, without GPU;
  * Portable & header-only;
  * Easy to integrate with real applications;
  * Simply implemented.

Package: tiny-dnn-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: header only deep learning framework in C++ -- documentation
 tiny-dnn is a C++ implementation of deep learning. It is suitable for deep
 learning on limited computational resource, embedded systems and IoT devices.
 .
 Features:
 .
  * Reasonably fast, without GPU;
  * Portable & header-only;
  * Easy to integrate with real applications;
  * Simply implemented.
 .
 This package contains the documentation.
