=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,repack,repacksuffix=+ds,dversionmangle=auto" \
 https://github.com/tiny-dnn/tiny-dnn/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
